import com.sun.jna.Library;
import com.sun.jna.Native;
//import com.sun.jna.Platform;  // for HelloWorld class

public class Beep extends Thread {
    public static int SOUND_FREQ = 880;
    private int times;
    private int msec;
    /** IO access 用ライブラリ */
    private InpOut32 inpOut32;

    public Beep() { this(1,1); }
    public Beep(int times, int msec) {    
        this.times = times;
        this.msec  = msec;
        try {
            inpOut32 = InpOut32.INSTANCE;
        } catch (NoClassDefFoundError e) {
        } catch (UnsatisfiedLinkError e) {
            // do nothing
        }
    }

    @Override
    public void run() {
        // HelloWorld.main(new String[]{"hoge", "fuga"}); // JNA test
        // beepKernel32();

        if (!isReady()) return;
        try {
            for (int i=0; i<times; i++) {
                beepStart(SOUND_FREQ);
                sleep(msec*2/3);
                beepStop();
                sleep(msec/3);
            }
        } catch (InterruptedException e) {
            //e.printStackTrace();
            beepStop();
        }
    }

    public void AsciiBell() {
        System.out.print("\007");
        System.out.flush();
    }

    public void beepKernel32() {
        Kernel32 kernel32 = Kernel32.INSTANCE;
        kernel32.Beep(698, 500);
        kernel32.Sleep(500);
        kernel32.Beep(698, 500);
    }
    
    interface Kernel32 extends Library {
        Kernel32 INSTANCE =
            (Kernel32) Native.loadLibrary("kernel32", Kernel32.class);
        boolean Beep(int dwFreq, int dwDuration);
        void Sleep(int dwMilliseconds);
    }
  
    public void beepStart(int freq) {
        int count = 1193180 / freq;
        inpOut32.Out32((short)0x61, (short)(inpOut32.Inp32((short)0x61) | 0x03));
        inpOut32.Out32((short)0x43, (short)0xB6);
        inpOut32.Out32((short)0x42, (short)(count & 0xFF));
        inpOut32.Out32((short)0x42, (short)(count >> 8));
    }

    public void beepStop() {
        inpOut32.Out32((short)0x61, (short)(inpOut32.Inp32((short)0x61) & 0xFC));
    }
    
    public boolean isReady() {
        return inpOut32 != null && inpOut32.IsInpOutDriverOpen();
    }
    
    interface InpOut32 extends Library {
        InpOut32 INSTANCE =
            (InpOut32) Native.loadLibrary("InpOut32", InpOut32.class);
        void Out32(short addr, short val);
        short Inp32(short addr);
        boolean IsInpOutDriverOpen();
        boolean IsXP64Bit();
    }
}



/*
// http://ja.wikipedia.org/wiki/Java_Native_Access
// Library の宣言と使用法の簡単な例
class HelloWorld {
    public interface CLibrary extends Library {
        CLibrary INSTANCE = (CLibrary) Native
        .loadLibrary(Platform.isWindows() ? "msvcrt" : "c", CLibrary.class);
        void printf(String format, Object... args);
    }
 
    public static void main(String[] args) {
        CLibrary.INSTANCE.printf("Hello, World\n");
        for (int i = 0; i < args.length; i++) {
            CLibrary.INSTANCE.printf("Argument %d: %s\n", i, args[i]);
        }
    }
}
*/
