import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;


public class Net extends Thread {
    private Preference preferenc;
    
    public Net(Preference preferenc) {
        this.preferenc = preferenc;
    }

    public String getURL() {
        String prot = preferenc.noticeNetProtocol();
        String addr = preferenc.noticeNetAddr();
        return extractEnv(prot + addr);
    }

    public String getURL(String addr) {
        String prot = preferenc.noticeNetProtocol();
        return extractEnv(prot + addr);
    }

    public String extractEnv(String s) {
        Runtime r = Runtime.getRuntime();
        try {
            Process process;
            if (preferenc.isUnix()) {
                process = r.exec(new String[]{ "sh", "-c", "echo \"" + s + "\"" });
            } else {
                process = r.exec("cmd /c echo " + s);
            }
            InputStream is = process.getInputStream();  //標準出力
            BufferedReader br = new BufferedReader(new InputStreamReader(is));
            String t = br.readLine();
            br.close();
            if (t != null) s = t; 
        } catch (IOException e) {
            e.printStackTrace();
        }
        return s;
    }

    private String result;
    public String getResult() {
        return result;
    }

    @Override
    public void run() {
        URL url;
        try {
            url = new URL(getURL());
        } catch (MalformedURLException e) {
            e.printStackTrace();
            result = "MalformedURL";
            return;
        }
        result = "";
        HttpURLConnection connection;
        try {
            connection = (HttpURLConnection)url.openConnection();
            connection.setRequestMethod("GET");
            connection.setInstanceFollowRedirects(false);
            connection.setDoOutput(false);
            connection.connect();

            // input
            BufferedReader in = new BufferedReader(new
                    InputStreamReader(connection.getInputStream()));
            String s;
            while ( (s=in.readLine()) != null ) {
                if (result.length() > 0) result += ", ";
                result += s;
                System.err.println(s);
            }
            in.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
